#include "extended_keymap_common.h"
#include "../keymap_rapooV500.h"

// QWERTY to QWERTZ:
// ROW 2, no shift
#define EN_GRAVE     S(KC_EQUAL)
#define EN_MINUS     KC_SLASH
#define EN_EQUAL     S(KC_0)
// ROW 3, no shift
#define EN_BRC_SQ_L  RALT(KC_8)
#define EN_BRC_SQ_R  RALT(KC_9)
#define EN_BSLS      RALT(KC_MINUS)
// ROW 4, no shift
#define EN_SCLN      S(KC_COMM)
#define EN_QUOT      S(KC_NONUS_HASH)
// ROW 5, no shift
#define EN_SLSH      S(KC_7)
// ROW 2, shift
#define EN_TILDE     RALT(KC_RBRACKET)
#define EN_AT        RALT(KC_Q)
#define EN_HASH      KC_NONUS_HASH
#define EN_CRCMFLX   KC_GRV
#define EN_ASTRSK    S(KC_RBRACKET)
#define EN_PLUS      KC_RBRACKET
// ROW 3, shift
#define EN_BRC_CU_L  RALT(KC_7)
#define EN_BRC_CU_R  RALT(KC_0)
#define EN_VSTROKE   RALT(KC_NUBS)
// ROW 4, shift      
#define EN_COLON     S(KC_DOT)
#define EN_DQUOTE    S(KC_2)
// ROW 5, shift      
#define EN_BRC_TR_L  KC_NUBS
#define EN_BRC_TR_R  S(KC_NUBS)
#define EN_QMARK     S(KC_MINUS)

// German Umlaute:
#define DE_sz       KC_MINUS
#define DE_OE       KC_SCLN
#define DE_UE       KC_LBRACKET     
#define DE_AE       KC_QUOTE    
#define DE_DEGREE   S(KC_GRAVE)

#define MY_LAYER_SHIFT 1
#define MY_LAYER_MOD   2
#define MY_LAYER_MODSHIFT 3
const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
   [0]=KEYMAP_RAPOOV500(    
// Base Layer:─
// ┌───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┐  ┌───────────┬───────────┬───────────┐
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │18
     KC_ESC    , KC_F1     , KC_F2     , KC_F3     , KC_F4     , KC_F5     , KC_F6     , KC_F7     , KC_F8     , KC_F9     , KC_F10    , KC_F11    , KC_F12    , KC_NO     , KC_NO     ,    KC_NO     , KC_NO     , KC_NO     ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │
// ├───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┴───────────┤  ├───────────┼───────────┼───────────┤
// │ --------  │           │           │           │           │           │           │           │           │           │           │ --------  │---------  │                       │  │           │           │           │17
     EN_GRAVE  , KC_1      , KC_2      , KC_3      , KC_4      , KC_5      , KC_6      , KC_7      , KC_8      , KC_9      , KC_0      , EN_MINUS  , EN_EQUAL  , KC_BSPACE             ,   KC_PSCREEN , KC_NO     , KC_PAUSE  ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │
// ├───────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────────────────┤  ├───────────┼───────────┼───────────┤
// │               │           │           │           │           │           │           │           │           │           │           │-----------│-----------│ -------           │  │           │           │           │17
     KC_TAB        , KC_Q      , KC_W      , KC_E      , KC_R      , KC_T      , KC_Z      , KC_U      , KC_I      , KC_O      , KC_P      ,EN_BRC_SQ_L,EN_BRC_SQ_R, EN_BSLS           ,    KC_INSERT , KC_HOME   , KC_PGUP   ,
// │               │           │           │           │           │           │           │           │           │           │           │           │           │                   │  │           │           │           │
// ├───────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────┤  ├───────────┼───────────┼───────────┤
// │ to mod layer      │           │           │           │           │           │           │           │           │           │ -------   │ -------   │                           │  │           │           │           │16
     KC_FN2            , KC_A      , KC_S      , KC_D      , KC_F      , KC_G      , KC_H      , KC_J      , KC_K      , KC_L      , EN_SCLN   , EN_QUOT   , KC_ENT                    ,    KC_DELETE , KC_END    , KC_PGDOWN ,
// │                   │           │           │           │           │           │           │           │           │           │           │           │                           │  │           │           │           │
// ├───────────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────────────┤  └───────────┼───────────┼───────────┘
// │ to shift layer        │           │           │           │           │           │           │           │           │           │ -------   │ to shift layer                    │              │           │            13
     KC_FN1                , KC_Y      , KC_X      , KC_C      , KC_V      , KC_B      , KC_N      , KC_M      , KC_COMM   , KC_DOT    , EN_SLSH   , KC_FN1                            ,                KC_UP     ,
// │                       │           │           │           │           │           │           │           │           │           │           │                                   │              │           │           
// ├───────────────────────┴───┬───────┴─────┬─────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───┬───────────────────────────────┤  ┌───────────┼───────────┼───────────┐
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │11
     KC_LCTL     , KC_LGUI     , KC_LALT     , KC_SPC                                                                  , KC_RALT       , KC_RGUI       , KC_RALT       , KC_RCTL       ,    KC_LEFT   , KC_DOWN   , KC_RGHT   )
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │
// └─────────────┴─────────────┴─────────────┴─────────────────────────────────────────────────────────────────────────┴───────────────┴───────────────┴───────────────┴───────────────┘  └───────────┴───────────┴───────────┘

,[MY_LAYER_SHIFT]=KEYMAP_RAPOOV500(  
// ┌───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┐  ┌───────────┬───────────┬───────────┐
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │18
     KC_ESC    ,S(KC_F1)   ,S(KC_F2)   ,S(KC_F3)   ,S(KC_F4)   ,S(KC_F5)   ,S(KC_F6)   ,S(KC_F7)   ,S(KC_F8)   ,S(KC_F9)   ,S(KC_F10)  ,S(KC_F11)  ,S(KC_F12)  , KC_NO     , KC_NO     ,    KC_NO     , KC_NO     , KC_NO     ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │
// ├───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┴───────────┤  ├───────────┼───────────┼───────────┤
// │ --------  │           │ -----     │ -------   │           │           │---------- │           │---------  │           │           │-----------│--------   │                       │  │           │           │           │17
     EN_TILDE  ,S(KC_1)    , EN_AT     , EN_HASH   ,S(KC_4)    ,S(KC_5)    ,EN_CRCMFLX ,S(KC_6)    ,EN_ASTRSK  ,S(KC_8)    ,S(KC_9)    ,S(EN_MINUS), EN_PLUS   ,S(KC_TRNS)             ,  S(KC_PSCREEN),S(KC_NO)  ,S(KC_PAUSE),
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │
// ├───────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────────────────┤  ├───────────┼───────────┼───────────┤
// │               │           │           │           │           │           │           │           │           │           │           │-----------│-----------│ ----------        │  │           │           │           │17
     S(KC_TAB)     ,S(KC_Q)    ,S(KC_W)    ,S(KC_E)    ,S(KC_R)    ,S(KC_T)    ,S(KC_Z)    ,S(KC_U)    ,S(KC_I)    ,S(KC_O)    ,S(KC_P)    ,EN_BRC_CU_L,EN_BRC_CU_R, EN_VSTROKE        ,  S(KC_INSERT),S(KC_HOME) ,S(KC_PGUP) ,
// │               │           │           │           │           │           │           │           │           │           │           │           │           │                   │  │           │           │           │
// ├───────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────┤  ├───────────┼───────────┼───────────┤
// │ to modshift layer │           │           │           │           │           │           │           │           │           │ --------  │ --------- │                           │  │           │           │           │16
     KC_FN3            ,S(KC_A)    ,S(KC_S)    ,S(KC_D)    ,S(KC_F)    ,S(KC_G)    ,S(KC_H)    ,S(KC_J)    ,S(KC_K)    ,S(KC_L)    , EN_COLON  , EN_DQUOTE ,S(KC_ENT)                  ,  S(KC_DELETE),S(KC_END)  ,S(KC_PGDOWN),
// │                   │           │           │           │           │           │           │           │           │           │           │           │                           │  │           │           │           │
// ├───────────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────────────┤  └───────────┼───────────┼───────────┘
// │ leave on release      │           │           │           │           │           │           │           │-----------│-----------│-----------│ leave on release                  │              │           │            13
     KC_FN0                ,S(KC_Y)    ,S(KC_X)    ,S(KC_C)    ,S(KC_V)    ,S(KC_B)    ,S(KC_N)    ,S(KC_M)    ,EN_BRC_TR_L,EN_BRC_TR_R, EN_QMARK  , KC_FN0                            ,                S(KC_UP)  , 
// │                       │           │           │           │           │           │           │           │           │           │           │                                   │              │           │           
// ├───────────────────────┴───┬───────┴─────┬─────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───┬───────────────────────────────┤  ┌───────────┼───────────┼───────────┐
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │11
     S(KC_LCTL)  , S(KC_LGUI)  , S(KC_LALT)  , S(KC_SPC)                                                               , S(KC_RALT)    , S(KC_RGUI)    , S(KC_RALT)    , S(KC_RCTL)    ,   S(KC_LEFT) ,S(KC_DOWN) ,S(KC_RGHT) )
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │
// └─────────────┴─────────────┴─────────────┴─────────────────────────────────────────────────────────────────────────┴───────────────┴───────────────┴───────────────┴───────────────┘  └───────────┴───────────┴───────────┘


,[MY_LAYER_MOD]=KEYMAP_RAPOOV500(
// ┌───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┐  ┌───────────┬───────────┬───────────┐
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │18
     KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │
// ├───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┴───────────┤  ├───────────┼───────────┼───────────┤
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │17
     DE_DEGREE , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS               ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │
// ├───────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────────────────┤  ├───────────┼───────────┼───────────┤
// │               │           │           │           │           │           │           │ -----     │ -----     │ -----     │           │           │           │                   │  │           │           │           │17
     KC_TRNS       , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , DE_UE     , KC_UP     , DE_OE     , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS           ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │               │           │           │           │           │           │           │           │           │           │           │           │           │                   │  │           │           │           │
// ├───────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────┤  ├───────────┼───────────┼───────────┤
// │ leave on release  │ -----     │ -----     │           │           │           │ -------   │ -------   │ -------   │ -------   │ ------    │           │                           │  │           │           │           │16
     KC_FN0            , DE_AE     , DE_sz     , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_HOME   , KC_LEFT   , KC_DOWN   , KC_RGHT   , KC_END    , KC_TRNS   , KC_TRNS                   ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │                   │           │           │           │           │           │           │           │           │           │           │           │                           │  │           │           │           │
// ├───────────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────────────┤  └───────────┼───────────┼───────────┘
// │ to modshift layer     │           │           │           │           │           │           │           │           │           │           │ to modshift layer                 │              │           │            13
     KC_FN3                , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_FN3                            ,                KC_TRNS   , 
// │                       │           │           │           │           │           │           │           │           │           │           │                                   │              │           │           
// ├───────────────────────┴───┬───────┴─────┬─────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───┬───────────────────────────────┤  ┌───────────┼───────────┼───────────┐
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │11
     KC_TRNS     , KC_TRNS     , KC_TRNS     , KC_TRNS                                                                 , KC_TRNS       , KC_TRNS       , KC_TRNS       , KC_TRNS       ,   KC_TRNS    ,KC_TRNS    ,KC_TRNS    )
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │
// └─────────────┴─────────────┴─────────────┴─────────────────────────────────────────────────────────────────────────┴───────────────┴───────────────┴───────────────┴───────────────┘  └───────────┴───────────┴───────────┘
,[MY_LAYER_MODSHIFT]=KEYMAP_RAPOOV500(
// ┌───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┐  ┌───────────┬───────────┬───────────┐
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │18
     KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │
// ├───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┴───────────┤  ├───────────┼───────────┼───────────┤
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │17
     KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS               ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │
// ├───────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────────────────┤  ├───────────┼───────────┼───────────┤
// │               │           │           │           │           │           │           │--------   │--------   │--------   │           │           │           │                   │  │           │           │           │17
     KC_TRNS       , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   ,S(DE_UE)   ,S(KC_UP)   ,S(DE_OE)   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS           ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │               │           │           │           │           │           │           │           │           │           │           │           │           │                   │  │           │           │           │
// ├───────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────┤  ├───────────┼───────────┼───────────┤
// │ leave on release  │--------   │           │           │           │           │---------- │---------- │---------- │---------- │---------  │           │                           │  │           │           │           │16
     KC_FN0            ,S(DE_AE)   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   ,S(KC_HOME) ,S(KC_LEFT) ,S(KC_DOWN) ,S(KC_RGHT) ,S(KC_END)  , KC_TRNS   , KC_TRNS                   ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │                   │           │           │           │           │           │           │           │           │           │           │           │                           │  │           │           │           │
// ├───────────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────────────┤  └───────────┼───────────┼───────────┘
// │ leave on release      │           │           │           │           │           │           │           │           │           │           │ leave on release                  │              │           │            13
     KC_FN0                , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_FN0                            ,                KC_TRNS   , 
// │                       │           │           │           │           │           │           │           │           │           │           │                                   │              │           │           
// ├───────────────────────┴───┬───────┴─────┬─────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───┬───────────────────────────────┤  ┌───────────┼───────────┼───────────┐
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │11
     KC_TRNS     , KC_TRNS     , KC_TRNS     , KC_TRNS                                                                 , KC_TRNS       , KC_TRNS       , KC_TRNS       , KC_TRNS       ,   KC_TRNS    ,KC_TRNS    ,KC_TRNS    )
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │
// └─────────────┴─────────────┴─────────────┴─────────────────────────────────────────────────────────────────────────┴───────────────┴───────────────┴───────────────┴───────────────┘  └───────────┴───────────┴───────────┘

/*
,[ ]=MYKEYMAP(  //Transparent Layer:
// ┌───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┬───────────┐  ┌───────────┬───────────┬───────────┐
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │18
     KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │           │           │  │           │           │           │
// ├───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┼───────────┴───────────┤  ├───────────┼───────────┼───────────┤
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │17
     KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS               ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │           │           │           │           │           │           │           │           │           │           │           │           │           │                       │  │           │           │           │
// ├───────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────────────────┤  ├───────────┼───────────┼───────────┤
// │               │           │           │           │           │           │           │           │           │           │           │           │           │                   │  │           │           │           │17
     KC_TRNS       , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS           ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │               │           │           │           │           │           │           │           │           │           │           │           │           │                   │  │           │           │           │
// ├───────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────┤  ├───────────┼───────────┼───────────┤
// │                   │           │           │           │           │           │           │           │           │           │           │           │                           │  │           │           │           │16
     KC_TRNS           , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS                   ,    KC_TRNS   , KC_TRNS   , KC_TRNS   ,
// │                   │           │           │           │           │           │           │           │           │           │           │           │                           │  │           │           │           │
// ├───────────────────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───┬───────┴───────────────────────────┤  └───────────┼───────────┼───────────┘
// │                       │           │           │           │           │           │           │           │           │           │           │                                   │              │           │            13
     KC_TRNS               , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS   , KC_TRNS                           ,                KC_TRNS   , 
// │                       │           │           │           │           │           │           │           │           │           │           │                                   │              │           │           
// ├───────────────────────┴───┬───────┴─────┬─────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───────────┴───┬───────────────────────────────┤  ┌───────────┼───────────┼───────────┐
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │11
     KC_TRNS     , KC_TRNS     , KC_TRNS     , KC_TRNS                                                                 , KC_TRNS       , KC_TRNS       , KC_TRNS       , KC_TRNS       ,   KC_TRNS    ,KC_TRNS    ,KC_TRNS    )
// │             │             │             │                                                                         │               │               │               │               │  │           │           │           │
// └─────────────┴─────────────┴─────────────┴─────────────────────────────────────────────────────────────────────────┴───────────────┴───────────────┴───────────────┴───────────────┘  └───────────┴───────────┴───────────┘
*/
};

const uint16_t PROGMEM fn_actions[] = {
    [0] = ACTION_LAYER_CLEAR(ON_RELEASE),  // leave on release
    [1] = ACTION_LAYER_SET(MY_LAYER_SHIFT   , ON_PRESS),  // shift layer
    [2] = ACTION_LAYER_SET(MY_LAYER_MOD     , ON_PRESS),  // mod layer
    [3] = ACTION_LAYER_SET(MY_LAYER_MODSHIFT, ON_PRESS),  // modshift layer
};

const macro_t *action_get_macro(keyrecord_t *record, uint8_t id, uint8_t opt) 
{

};
